#include "basic_auth.h"

bool is_connected(request_t *_request, response_t *_response,io_t *_out)
{
	char **login_passwd;//login and password send by the client
	char tmp_passwd[100];
	const char *valeur=NULL;
	int i;
	char *decode;
	
	//get login and password
	valeur = request_get_field_value(_request,"Authorization");
	
	if(valeur!=NULL)
	{	
		//remove the "Basic " word of base64 string
		valeur += 6;

		//decode this string
		decode = base64decode(valeur);
		//distinguish the login and the password
		login_passwd = explode(decode,':');// ':' is the separator of login and password 
		free(decode);//free this 
		valeur = NULL;
		
		//compare the login with a static string
		if(strcmp("toto",login_passwd[0])==0)//toto is the accepted login
		{
			//compare the password with a static string
			if(login_passwd[2]==NULL && strcmp("1234",login_passwd[1])==0)//1234 is the accepted password 
			{
				free_explode(login_passwd);
				return true;
			}
		}
		free_explode(login_passwd);
	}
	
	//the user is refused
	response_set_status(_response, 401);//HTTP 401 error
	response_set_field(_response,"WWW-Authenticate", "Basic realm=\"Identification\"");//"Identification" is the personnal message for dialog box
	response_set_field(_response,"Cache-Control","no-cache");
	response_set_field(_response,"Connection","close");
	//HTML page for the client
	io_printf(_out,"<html><head><title>Basic access authentification</title></head><body><p style=\"color:red\">Failure authentification</p></body></html>");
	
	return false;
}

char** explode(const char* str, char separator)
{
    char buf[250];
    char c;
    char* ptr=NULL;
    char** res = NULL;
    int nbmot = 0;
    int taillemot = 0;
    int i;
    
		if(str==NULL)
			return NULL;

    ptr = buf;
    
    for(i=0; i<=strlen(str); i++)
    {
        c=str[i];
        
        if(c==separator || i==strlen(str))
        {
            *ptr = '\0';
            nbmot++;
            res = (char **) realloc(res, nbmot * sizeof(char*));
            res[nbmot-1]=strdup(buf);
            taillemot=0;
            ptr = buf;
        }
        else
        {
            *ptr ++ = c;
            taillemot++;
        }
    }
    res = (char **) realloc(res, (nbmot+1) * sizeof(char*));
    res[nbmot] = NULL;
    
    return res;
}

void free_explode(char **var)
{
    int i;
    if(var!=NULL)
    {
        for(i=0; var[i]!=NULL; i++)
            free(var[i]);
        free(var);
    }
}

char *base64decode(const char *encodedstring)
{
	char inalphabet[256], decoder[256];
	unsigned char alphabet[64] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
	int i;
	int bits, c;
	int char_count;
	int errors = 0;//number of found error
	char *res;//decoded string "login:mdp\0"
	char *ptr=NULL;

	//initialisation of arrays
	memset(inalphabet,0,256*sizeof(char));
	memset(decoder,0,256*sizeof(char));
	res = (char *)malloc(MAX_SIZE_OF_LOGIN_PASSWORD*sizeof(char));
	memset(res,0,MAX_SIZE_OF_LOGIN_PASSWORD*sizeof(char));

	for(i = (sizeof alphabet) - 1; i >= 0 ; i--)
	{
		inalphabet[alphabet[i]] = 1;
		decoder[alphabet[i]] = i;
	}

	char_count = 0;
	bits = 0;
	ptr = (char *)encodedstring;
	i=0;
	while((c = *(ptr++)) != '\0')
	{
		if(c == '=')
			break;
		if(c > 255 || !inalphabet[c])
			continue;
		bits += decoder[c];
		char_count++;
		if(char_count == 4)
		{
			res[i++]=((bits >> 16));
			res[i++]=(((bits >> 8) & 0xff));
			res[i++]=((bits & 0xff));
			bits = 0;
			char_count = 0;
		}
		else
		{
			bits <<= 6;
		}
	}
	if(c == '\0')
	{
		if(char_count)
		{
			//base64 encoding incomplete: at least ((4 - char_count) * 6)) bits truncated
			errors++;
		}
	}
	else
	{ /* c == '=' */
		switch (char_count)
		{
			case 1:
				//base64 encoding incomplete: at least 2 bits missing
				errors++;
				break;
			case 2:
				res[i++]=((bits >> 10));
				break;
			case 3:
				res[i++]=((bits >> 16));
				res[i++]=(((bits >> 8) & 0xff));
				break;
		}
	}
	res[i]='\0';
	//no error
	if(errors==0)
		return res;
	
  //found error
  free(res);
	return NULL;
}
