/**
* @author: AUGER Mickael
* 
* Authenfication with HTTP basic method
*/
#ifndef BASIC_AUTH
#define BASIC_AUTH

#include <klone/klone.h>
#include <klone/context.h>

#include <stdlib.h>
#include <string.h>
#include <stdbool.h>
#include <sys/stat.h>
#include <regex.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

//maximum length of string concatenation of login and password 
#define MAX_SIZE_OF_LOGIN_PASSWORD 100

/**
* Test if the user (client) is connected.
* This function must be call by all pages protected by password.
* @param _request request (global var) of KLone server
* @param _response response (global var) of KLone server
* @param _out standard output (global var) of KLone server
* @return false if the user is not connected
*/ 
bool is_connected(request_t *_request, response_t *_response,io_t *_out);

/**
* Split a string by character.
* The last word of array is NULL
* Warning : this array must be free after use with the 'free_explode' function
* @param str The input string 
* @param separator The boundary character
* @return a array with NULL like last value
*/
char** explode(const char* str, char separator);

/**
* Free an array initialized by the "explode" function
* @param var the array
*/
void free_explode(char **var);

/**
* Decode a base64 string like "login:password"
* Warning : free the returned string after use
* @param encodedstring string encoded in base64
* @return decoded string like "login:password"
*/
char *base64decode(const char *encodedstring);

#endif
